package edu.vub.at.simonsays;

import java.util.Random;
import java.util.Vector;

import edu.vub.at.simonsays.interfaces.SimonGUI;
import android.os.AsyncTask;
import android.widget.Button;


//_________       _____  __                                  .____                                                               .____          ___.    
///   _____/ _____/ ____\/  |___  _  _______ _______   ____   |    |   _____    ____    ____  __ _______     ____   ____   ______ |    |   _____ \_ |__  
//\_____  \ /  _ \   __\\   __\ \/ \/ /\__  \\_  __ \_/ __ \  |    |   \__  \  /    \  / ___\|  |  \__  \   / ___\_/ __ \ /  ___/ |    |   \__  \ | __ \ 
///        (  <_> )  |   |  |  \     /  / __ \|  | \/\  ___/  |    |___ / __ \|   |  \/ /_/  >  |  // __ \_/ /_/  >  ___/ \___ \  |    |___ / __ \| \_\ \
///_______  /\____/|__|   |__|   \/\_/  (____  /__|    \___  > |_______ (____  /___|  /\___  /|____/(____  /\___  / \___  >____  > |_______ (____  /___  /
//   \/                                 \/            \/          \/    \/     \//_____/            \//_____/      \/     \/          \/    \/    \/ 
//
//Distributed and Mobile Paradigms Course 
//Lab Session 1


public class Sequence {
	// sequence of colors (represented as integers) 
	private Vector<Integer> currentSequence  = new Vector<Integer>();
	private Random r = new Random();
	// index on the sequence 
	// used to check whether the color the user is pressing matches the sequence 
	private int currentPosition;
	
	// returns if the end of the sequence is reached
	public boolean isEnd() {
		return currentPosition == currentSequence.size();
	}
	// adds a new color to the sequence.
	public void extend() {
		currentSequence.add(Math.abs(r.nextInt() % (SimonActivity.simon_colors.length-1)));
	}
	// returns the length of the sequence.
	public int getLength(){ 
		return currentSequence.size();
	}
	// asks the GUI to hightlight the buttons according go to the sequence
	public void play(ButtonAdapter buttonAdapter, final SimonGUI s) {
		currentPosition = 0;
		AsyncTask<ButtonAdapter, Void, Void> task  =  new AsyncTask<ButtonAdapter, Void, Void>() {
			@Override
			protected Void doInBackground(ButtonAdapter... params) {
				ButtonAdapter buttonAdapter = params[0];
				int pos = 0;
				while (pos < currentSequence.size()){
					try {
						 Thread.sleep(1000);
					 } catch(Exception e) {
						System.out.println(e.getMessage()); 
					 }
					 int button_id = currentSequence.elementAt(pos);
					 Button button = (Button) buttonAdapter.getItem(button_id);
					 s.highlightButton(button, currentSequence.get(pos) );
					 try {
						 Thread.sleep(1000);
					 } catch(Exception e) {
						System.out.println(e.getMessage()); 
					 }
					 s.normalButton(button,currentSequence.get(pos));
					 pos = pos +1;
				}				
				return null;
			}
		};		
		task.execute(buttonAdapter);
	}
	// checks whether a given color matches the color in the current index of the sequence
	public boolean match(int color) {
		return currentSequence.get(currentPosition++) == color;
	}	
}
